=begin
------------------------------------------------------------------------
Copyright 2008, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name:          	default_layer_geometry.rb
Description:   	Defaults all layers for all selected geometry.  
                Groups and Instances are not changed 
                BUT their contents are zeroed
Author:       	TIG
Usage:			1. Select one of more entities. 
				    2. Activate the script from the Plugins Menu  
History:		1.0 20080310	First issue.
=end
#-----------------------------------------------------------------------------
require 'sketchup.rb' 
class DefaultLayerGeometry 
  def to_default(entity)  
    entity.definition.entities.each{|e|to_default(e)}if entity.typename=="ComponentInstance"
    entity.entities.each{|e|to_default(e)}if entity.typename=="Group"
    entity.layer=nil if entity.typename!="ComponentInstance" and entity.typename!="Group"
    ### only processes non-group or compo-def layers
  end#def to_default 
  def process() 
    Sketchup.active_model.selection.each{|e|to_default(e)} 
  end#def process 
end#class
###
def default_layer_geometry
  if not Sketchup.active_model.selection[0] 
    UI.messagebox("Default Layer Geometry:\nSelect Objects BEFORE Running.")
    return nil
  end#if
  Sketchup.active_model.start_operation("Default Layer Geometry")
   DefaultLayerGeometry.new.process
  Sketchup.active_model.commit_operation
end#def
#-----------------------------------------------------------------------
is_this_file=File.basename(__FILE__)
if not file_loaded?(is_this_file)
    UI.menu("Plugins").add_item("Default Layer Geometry") {default_layer_geometry}
end#if
#-----------------------------------------------------------------------
file_loaded(is_this_file)
